# 6.0002 Problem Set 2 Spring 2020
# Graph Optimization
# Name:
# Collaborators:
# Time:

#
# Finding shortest paths to drive from home to work on a road network
#


import unittest
from graph import DirectedRoad, Node, RoadMap


# PROBLEM 2: Building the Road Network
#
# PROBLEM 2a: Designing your Graph
#
# What do the graph's nodes represent in this problem? What
# do the graph's edges represent? Where are the times
# represented?
#
# ANSWER:
#
#


# PROBLEM 2b: Implementing load_map
def load_map(map_filename):
    """
    Parses the map file and constructs a road map (graph).

    Parameters:
    map_filename - name of the map file

    Assumes:
    Each entry in the map file consists of the following format, separated by tabs:
        From To TotalTime  RoadType
        e.g.
            N0	N1	15	interstate
    This entry would become an edge from 'N0' to 'N1' on an interstate highway with 
    a weight of 15. There should also be another edge from 'N1' to 'N0' on an interstate
    using the same weight.

    Returns:
    a directed road map representing the inputted map
    """
    pass


# PROBLEM 2c: Testing load_map
# Include the lines used to test load_map below, but comment them out


# PROBLEM 3: Finding the Shortest Path using Optimized Search Method
#
# PROBLEM 3a: Objective function
#
# What is the objective function for this problem? What are the constraints?
#
# ANSWER:


# PROBLEM 3b: Implement get_optimal_path
def get_optimal_path(roadmap, start, end, restricted_roads, in_traffic=False):
    """
    Finds the shortest path between nodes subject to constraints.

    Parameters:
    roadmap - RoadMap
        The graph on which to carry out the search
    start - Node
        node at which to start
    end - Node
        node at which to end
    restricted_roads - list[strings]
        Road Types not allowed on path
    in_traffic - boolean
        flag to indicate whether to get shortest path during heavy or normal traffic 

    Returns:
    A tuple of the form (best_path, best_time).
        The first item is the shortest-path from start to end, represented by
        a list of nodes (Nodes).
        The second item is an integer, the length (time traveled)
        of the best path.

    If there exists no path that satisfies constraints, then return None.
    """

    pass


# PROBLEM 4a: Implement optimal_path_no_traffic
def optimal_path_no_traffic(filename, start, end):
    """
    Finds the shortest path from start to end during ideal traffic conditions.

    You must use get_optimal_path and load_map.

    Parameters:
    filename - name of the map file that contains the graph
    start - Node, node object at which to start
    end - Node, node object at which to end
    
    Returns:
    list of Node objects, the shortest path from start to end in normal traffic.
    If there exists no path, then return None.
    """
    pass

# PROBLEM 4b: Implement optimal_path_restricted
def optimal_path_restricted(filename, start, end):
    """
    Finds the shortest path from start to end when local roads cannot be used.
    Assume there is NO traffic.

    You must use get_optimal_path and load_map.

    Parameters:
    filename - name of the map file that contains the graph
    start - Node, node object at which to start
    end - Node, node object at which to end
    
    Returns:
    list of Node objects, the shortest path from start to end given the aforementioned conditions,
    If there exists no path that satisfies constraints, then return None.
    """
    pass

# PROBLEM 4c: Implement optimal_path_heavy_traffic
def optimal_path_heavy_traffic(filename, start, end):
    """
    Finds the shortest path from start to end in heavy traffic,
    i.e. when local roads take twice as long. 

    You must use get_optimal_path and load_map.

    Parameters:
    filename - name of the map file that contains the graph
    start - Node, node object at which to start
    end - Node, node object at which to end; you may assume that start != end
    
    Returns:
    The shortest path from start to end given the aforementioned conditions, 
    represented by a list of nodes (Nodes).

    If there exists no path that satisfies the constraints, then return None.
    """
    pass

def __main__():
    pass # do not delete or comment out this pass statement
    
    # UNCOMMENT THE FOLLOWING LINES TO DEBUG

    #rmap = load_map('road_map.txt')
    #start = Node('N0')
    #end = Node('N9')
    #restricted_roads = ['']
    #
    #print(get_optimal_path(rmap, start, end, restricted_roads))
